//Do not edit! This file was generated by Unity-ROS MessageGeneration.
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Unity.Robotics.ROSTCPConnector.MessageGeneration;

namespace RosMessageTypes.RosTcpEndpoint
{
    [Serializable]
    public class DomainTaskGoal : Message
    {
        public const string k_RosMessageName = "rise_core/DomainTask";
        public override string RosMessageName => k_RosMessageName;

        // domain-task
        public string domain_task_behavior;
        public string function_type;
        public string calling_type;

        public DomainTaskGoal()
        {
            this.domain_task_behavior = "";
            this.function_type = "";
            this.calling_type = "";
        }

        public DomainTaskGoal(string domain_task_behavior, string function_type, string calling_type)
        {
            this.domain_task_behavior = domain_task_behavior;
            this.function_type = function_type;
            this.calling_type = calling_type;
        }

        public static DomainTaskGoal Deserialize(MessageDeserializer deserializer) => new DomainTaskGoal(deserializer);

        private DomainTaskGoal(MessageDeserializer deserializer)
        {
            deserializer.Read(out this.domain_task_behavior);
            deserializer.Read(out this.function_type);
            deserializer.Read(out this.calling_type);
        }

        public override void SerializeTo(MessageSerializer serializer)
        {
            serializer.Write(this.domain_task_behavior);
            serializer.Write(this.function_type);
            serializer.Write(this.calling_type);
        }

        public override string ToString()
        {
            return "DomainTaskGoal: " +
            "\ndomain_task_behavior: " + domain_task_behavior.ToString() +
            "\nfunction_type: " + function_type.ToString() +
            "\ncalling_type: " + calling_type.ToString();
        }

#if UNITY_EDITOR
        [UnityEditor.InitializeOnLoadMethod]
#else
        [UnityEngine.RuntimeInitializeOnLoadMethod]
#endif
        public static void Register()
        {
            MessageRegistry.Register(k_RosMessageName, Deserialize, MessageSubtopic.Goal);
        }
    }
}
